package com.localmatters;

import com.localmatters.consumer.ResultMessage;
import com.localmatters.producer.ProducerWSService;
import com.localmatters.producer.ProducerWS;
import com.localmatters.consumer.ConsumerWSService;
import com.localmatters.consumer.ConsumerWS;
import java.io.ByteArrayOutputStream;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import javax.xml.namespace.QName;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;
import org.w3c.dom.Document;

/**
 *
 * @author Daniel Cavalcanti
 */
public class Driver {
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args)
    throws Exception {
        
        System.out.println(new String(getDocument()));
        
        ProducerWSService producerService = new ProducerWSService(new URL("http://collector.isxinc.com/collector-5.1.0/Producer?WSDL"), new QName("http://producer.collector.flexiq.localmatters.com/", "ProducerWSService"));
//        ProducerWSService producerService = new ProducerWSService(new URL("http://localhost:8080/collector-5.1.0/Producer?WSDL"), new QName("http://producer.collector.flexiq.localmatters.com/", "ProducerWSService"));
        ProducerWS producerPort = producerService.getProducerWSPort();
        
        int MSGS_COUNT = 10;
        String username = "guest";
        String password = "guest";
        List<byte[]> msgs = new ArrayList<byte[]>();
        msgs.add(getDocument());
        
        
        for (int i = 0 ; i < MSGS_COUNT ; i++)
            producerPort.send(msgs, username, password);
        
        ConsumerWSService consumerService = new ConsumerWSService(new URL("http://collector.isxinc.com/collector-5.1.0/Consumer?WSDL"), new QName("http://consumer.collector.flexiq.localmatters.com/", "ConsumerWSService"));
//        ConsumerWSService consumerService = new ConsumerWSService(new URL("http://localhost:8080/collector-5.1.0/Consumer?WSDL"), new QName("http://consumer.collector.flexiq.localmatters.com/", "ConsumerWSService"));
        ConsumerWS consumerPort = consumerService.getConsumerWSPort();
        
        List<ResultMessage> result = consumerPort.retrieve(username, password, "jms/RequestQueue", MSGS_COUNT, false);
        System.out.println(String.valueOf(result));
        
    }
    
    private static byte[] getDocument()
    throws Exception {
        
        final String message = "collector-message-sample.xml";
//        final String message = "collector-message-legacy.xml";
        
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        DocumentBuilder db = dbf.newDocumentBuilder();
        Document dom = db.parse(Driver.class.getClassLoader().getResourceAsStream(message));
        
        TransformerFactory tf = TransformerFactory.newInstance();
        Transformer t = tf.newTransformer();
        
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        t.transform(new StreamSource(Driver.class.getClassLoader().getResourceAsStream(message)), new StreamResult(baos));
        
        return baos.toByteArray();
        
    }
    
}
